#!/bin/sh

if [ ! -e /usr/bin/perl ] || [ ! -e /usr/bin/gs ] ; then
  Xdialog --infobox "The Perl package and the Ghostscript package must be installed for this driver to work. One of them is missing.
  Install the missing packages and then re-install this driver." 0 0 100000
  exit
fi
geany /usr/share/doc/readme-brother-driver.txt &

  Xdialog --yesno "Will the printer be connected to the USB port? 
  If not we'll ask for an IP address.  " 0 0
  if [ $? -eq 1 ] ; then
  USB=0
  Xdialog --inputbox "Enter the IP address of the printer." 0 0 2> /tmp/inputbox.tmp.$$
  retval=$?
  ipAdd=`cat /tmp/inputbox.tmp.$$`
  rm -f /tmp/inputbox.tmp.$$
  
  case $retval in
  1)
    exit;;
  255)
    exit;;
  esac
  #only supporting scanning for network printers
  Xdialog --inputbox "Enter the model name for scanning from the list." 0 0 2> /tmp/inputbox.tmp.$$
  retval=$?
  modelName=`cat /tmp/inputbox.tmp.$$`
  rm -f /tmp/inputbox.tmp.$$
  
  case $retval in
  1)
    exit;;
  255)
    exit;;
  esac
  else
  USB=1
  fi

##########Cups Wrapper install##########

if [ ! -e /usr/bin/perl ] && [ "/usr/bin/perl" != ''  ];then
  if [ -e "/usr/bin/perl" ];then
    echo ln -s "/usr/bin/perl"  /usr/bin/perl
    ln -s "/usr/bin/perl"  /usr/bin/perl
  fi
fi
if [ ! -e /usr/bin/perl ]; then
  echo ' ****** WARNING: /usr/bin/perl is required. ******'
fi
rm /usr/lib64/cups/filter/brother_lpdwrapper_BrGenML1
ln -s /opt/brother/Printers/BrGenML1/cupswrapper/lpdwrapper      /usr/lib64/cups/filter/brother_lpdwrapper_BrGenML1


if [ -e /usr/share/cups/model ];then
  ln -s /opt/brother/Printers/BrGenML1/cupswrapper/brother-BrGenML1-cups-en.ppd      /usr/share/cups/model
  PPDDIR=/usr/share/cups/model/
fi
if [ -e /usr/share/ppd ];then
  if [ ! -e /usr/share/ppd/brother ];then
    mkdir /usr/share/ppd/brother
  fi
  ln -s /opt/brother/Printers/BrGenML1/cupswrapper/brother-BrGenML1-cups-en.ppd      /usr/share/ppd/brother
  PPDDIR=/usr/share/ppd/brother/
fi
uris=$(lpinfo -v)

for uri in $uris
do  
  URI=$(echo $uri | grep "BrGenML1" | grep usb)
  if [ "$URI" != '' ];then
    break;
  fi
done

if [ "$URI" = '' ];then
  for uri in $uris
  do  
    URI=$(echo $uri | grep "BrGenML1")
    if [ "$URI" != '' ];then
      break;
    fi
  done
fi

if [ "$URI" = '' ];then
  for uri in $uris
  do
    URI=$(echo $uri | grep -i "Brother" | grep usb)
    if [ "$URI" != '' ];then
      break;
    fi
  done
fi
if [ "$URI" = '' ];then
  for uri in $uris
  do
    URI=$(echo $uri | grep usb)
    if [ "$URI" != '' ];then
      break;
    fi
  done
fi

if [ "$URI" = '' ];then
  URI="usb://dev/usb/lp0"
fi

if [ "$USB" = "1" ];then
echo lpadmin -p BrGenML1  -E -v $URI -P ${PPDDIR}brother-BrGenML1-cups-en.ppd
lpadmin -p BrGenML1 -E -v $URI -P ${PPDDIR}brother-BrGenML1-cups-en.ppd
else
#network printer
echo lpadmin -p $modelName -E -v socket://$ipAdd:9100/ -P ${PPDDIR}brother-BrGenML1-cups-en.ppd
lpadmin -p $modelName -E -v socket://$ipAdd:9100/ -P ${PPDDIR}brother-BrGenML1-cups-en.ppd
fi

##############LPR wrapper Install################33

/opt/brother/Printers/BrGenML1/inf/setupPrintcap BrGenML1 -i USB
#/opt/brother/Printers/BrGenML1/inf/braddprinter -i BrGenML1
if [ -e /etc/init.d/lprng ]; then
     /etc/init.d/lprng restart
elif [ -e /etc/init.d/lpd ]; then
     /etc/init.d/lpd restart
fi
if [ ! -e /usr/sbin/pstops ];then
 PSTOPS=/usr/bin/pstops
 if [ "`echo $PSTOPS | grep -i cups`" != "" ];then
  PSTOPS=""
 fi
fi

ln -s /opt/brother/Printers/BrGenML1/inf/brBrGenML1rc       /etc/opt/brother/Printers/BrGenML1/inf/brBrGenML1rc

if [ ! -e /usr/bin/brprintconflsr3_BrGenML1 ];then
 echo "#! /bin/sh"  > /usr/bin/brprintconflsr3_BrGenML1
 echo "/opt/brother/Printers/BrGenML1/lpd/brprintconflsr3 -P BrGenML1" '$''*'           >>/usr/bin/brprintconflsr3_BrGenML1
  chmod 755 /usr/bin/brprintconflsr3_BrGenML1
fi

if [ ! -e /usr/bin/perl ] && [ "/usr/bin/perl" != ''  ];then
  if [ -e "/usr/bin/perl" ];then
    echo ln -s "/usr/bin/perl"  /usr/bin/perl
    ln -s "/usr/bin/perl"  /usr/bin/perl
  fi
fi
if [ ! -e /usr/bin/perl ]; then
  echo ' ****** WARNING: /usr/bin/perl is required. ******'
fi

#### Udev rules ########

#ln -s /lib64/udev /lib/
#/opt/brother/scanner/udev-rules/type1/install -i

/opt/brother/scanner/brscan4/udev_config.sh

#####Scanner Install##########

echo "This software is based in part on the work of the Independent JPEG Group."
if [ -e /usr/lib/sane ];then
if [ ! -e /usr/lib/sane/libsane-brother4.so.1.0.7 ];then
ln -s /usr/lib64/sane/libsane-brother4.so.1.0.7 /usr/lib/sane/libsane-brother4.so.1.0.7
ln -s /usr/lib64/sane/libsane-brother4.so.1.0.7 /usr/lib/sane/libsane-brother4.so.1
ln -s /usr/lib64/sane/libsane-brother4.so.1.0.7 /usr/lib/sane/libsane-brother4.so
fi
fi
if [ -e /usr/lib/x86_64-linux-gnu/sane ];then
if [ ! -e /usr/lib/x86_64-linux-gnu/sane/libsane-brother4.so.1.0.7 ];then
ln -s /usr/lib64/sane/libsane-brother4.so.1.0.7 /usr/lib/x86_64-linux-gnu/sane/libsane-brother4.so.1.0.7
ln -s /usr/lib64/sane/libsane-brother4.so.1.0.7 /usr/lib/x86_64-linux-gnu/sane/libsane-brother4.so.1
ln -s /usr/lib64/sane/libsane-brother4.so.1.0.7 /usr/lib/x86_64-linux-gnu/sane/libsane-brother4.so
fi
fi
/opt/brother/scanner/brscan4/setupSaneScan4 -i

if [ "$USB" = "0" ];then
brsaneconfig4 -a name=SCANNER model=$modelName ip=$ipAdd
fi

